<template>
    <div class="row justify-center items-center q-py-md">
        <div class="row items-center col-6 font-18 text-black q-mt-xs">
            <q-btn class="
                q-pr-sm 
                q-pl-lg-md 
                q-pl-md-md 
                q-pl-sm-md 
                q-pl-xs-none" 
                flat 
                no-caps 
                @click="selectCurrentPage(1)">
                <q-icon name="arrow_back" color="black" size="25px" />
            </q-btn>
            <div class="label-title-container helvetica-neue-medium">
                {{ $t('preference.createService') }}
            </div>
        </div>
        <div class="col-6 q-pr-md-xl font-18 text-black q-mt-xs text-right">
            <q-btn
                no-caps
                text-color="white"
                class="button-save"
                :label="$t('button.save')"
                @click="createService"
            />
        </div>
    </div>
    <div
        class="
            row
            justify-start
            items-center
            q-px-xs-lg q-px-sm-lg
        "
    >
        <div class="col-md-4 col-12 q-mt-xs items-center q-mr-md">
            <p class="font-14 q-mb-md helvetica-neue-medium">
                {{ $t('preference.serviceName') }}
                <span class="text-ff0000 font-10" v-if="!state.serviceName">
                    {{ $t('form.required') }}
                </span>
            </p>
            <q-input
                outlined
                dense
                v-model="state.serviceName"
                bg-color="blue-2"
            ></q-input>
        </div>
        <div class="col-md-4 col-12 items-center q-pt-md-none q-pt-xs-md">
            <p class="font-14 q-mb-md-none q-mb-xs-none helvetica-neue-medium">
                {{ $t('preference.serviceParent') }}
            </p>
            <q-select 
                v-model="state.parentName"
                :options="state.parentService"
                option-value="id"
                option-label="name"
            ></q-select>
        </div>
    </div>
</template>
<script lang="ts">
import { defineComponent, reactive, computed, onMounted } from 'vue'
import { useStore } from 'src/store';

export default defineComponent({
    name: 'CreateService',
    components: {

    },
    setup(props, { emit }) {
        let state = reactive({
            serviceName: '' as any,
            parentName: '' as any,
            parentService: [] as any,
        });
        const serviceList = computed(() => {
            return store.state.service.serviceType;
        });
        const store = useStore();
        const selectCurrentPage = (page: any) => {
            emit('update-servicePage', page);
        };

        const getParentService = () => {
            if (serviceList.value) {
                serviceList.value.forEach((element: any) => {
                    if (!element.parentId) {
                        let parentList = {
                            id: element.id,
                            name: element.name
                        };
                        state.parentService.push(parentList);
                    }
                })
            }
        }

        const createService = async () => {
            const res = await store.dispatch('service/create', {
                name: state.serviceName,
                parentId: state.parentName.id
            });
            if (res.status == 200) {
                selectCurrentPage(1);
            }
        }

        onMounted(getParentService);
        return {
            state,
            selectCurrentPage,
            createService,
            serviceList
        }
    },
})
</script>
